Return-Path: <tegra!vail@uunet.UU.NET>
Received: from relay2.UU.NET by rpi.edu (4.1/SMHUB31);
	id AA16418; Wed, 12 Feb 92 19:28:47 EST for glickj
Received: from uunet.uu.net (via LOCALHOST.UU.NET) by relay2.UU.NET with SMTP 
	(5.61/UUNET-internet-primary) id AA19623; Wed, 12 Feb 92 19:28:13 -0500
Received: from tegra.UUCP by uunet.uu.net with UUCP/RMAIL
	(queueing-rmail) id 192753.26971; Wed, 12 Feb 1992 19:27:53 EST
Received: from atlas by tegra.com (4.1/SMI-4.1)
	id AA01767; Wed, 12 Feb 92 18:52:44 EST
Date: Wed, 12 Feb 92 18:52:43 EST
From: tegra!vail@uunet.UU.NET (Johnathan Vail)
Message-Id: <9202122352.AA01767@tegra.com>
Received: by atlas (4.1/SMI-4.0)
	id AA03318; Wed, 12 Feb 92 18:52:22 EST
To: uunet!rpi.edu!glickj@uunet.UU.NET
Subject: birdie
Status: R

#----cut here-----cut here-----cut here-----cut here-----
#!/bin/sh
# This is a shell archive:
# 1. Remove everything above the cut line.
# 2. Feed as input to /bin/sh (not csh) to create the files:
#	Makefile
#	Read.me
#	bird.h
#	birdie.c
#	birdsite.DB
#	lstkepl.c
#	norad.dat
#	pk_kepl.c
#	unikepl.c
# Wrapped by: clb@loci.uucp	: Thu Nov 17 07:30:48 1988 UTC

export PATH; PATH=/bin:$PATH
if test -f 'Makefile'
then
	echo shar: will not over-write existing file "'Makefile'"
else
echo shar: x - Makefile
sed 's/^X//' << \SHAR_EOF > 'Makefile'
X
XSYSFLG = -DUSG
X#SYSFLG = -DBSD
X#SYSFLG = -DMSDOS
X
Xall	:	pk_kepl lstkepl unikepl birdie sats.DB
X	strip pk_kepl lstkepl unikepl birdie
X
Xpk_kepl	:	bird.h pk_kepl.c
X	cc $(SYSFLG) -o $@ pk_kepl.c
X
Xlstkepl	:	bird.h lstkepl.c
X	cc $(SYSFLG) -o $@ lstkepl.c
X
Xunikepl	:	unikepl.c
X	cc $(SYSFLG) -o $@ unikepl.c
X
Xbirdie	:	bird.h birdie.c
X	cc $(SYSFLG) -o $@ birdie.c -lm
X
Xsats.DB	:	norad.dat
X	pk_kepl < norad.dat
SHAR_EOF
fi # end of overwriting check
if test -f 'Read.me'
then
	echo shar: will not over-write existing file "'Read.me'"
else
echo shar: x - Read.me
sed 's/^X//' << \SHAR_EOF > 'Read.me'
X/*
X	Copyright (C) 1988, CLBrunow, All rights reserved.
X
X	These programs are intended for hobbiest use only and
X	may not be sold.  The programs may only be distributed
X	intact, including this paragraph, and no portion may
X	be used in any other program or software application
X	without prior written permission of the author. (Use the
X	methods, ideas, and formulas but re-write them in your
X	own style.)
X
X/**/
X
X		birdie: Loci Satellite Orbit Routines
X
X	This package provides a simple set of routines to estimate
X	satellite positions from the NORAD keplerian elements which
X	are posted to sci.space or from other sources. These programs
X	were developed and run under Unix SysV, but should be readily
X	convertible to similar OS's, such as BSD, Xenix, etc. 
X
X	While the methods of the program "birdie" are not as rigorous
X	as the SGP model the resulting orbital positions compare quite
X	well with it for most satellites. The greatest differences can
X	be expected for those sats which are in the lowest orbits where
X	atmospheric drag is most pronounced. These programs are designed
X	to be simple so that they can be used on smaller systems where
X	speed may be a factor.
X
XPROGRAMS:
X
X	pk_kepl	-	convert NORAD format data to compacted form
X			used by sat programs. Accepts data on stdin
X			and creates data file.
X
X	lstkepl -	list data from compacted format in either NORAD
X			or AMSAT formats.
X
X	unikepl	-	concatenates NORAD format data into 1-line format
X			for use with "sort (1)". Optional -r flag reverses
X			the operation, restoring NORAD format.
X
X	birdie	-	satellite orbit calculator program. Displays
X			keplerian and derived data, estimates positions
X			for selected times, lists sats above horizon for
X			selected time, and estimates positions over time
X			of selected satellite.
X
X
XFILES:
X
X	sats.DB		compacted keplerian data; created by "pk_kepl".
X
X	birdsite.DB	observer longitude/latitude.
X
X		to change these default locations, see "bird.h"
X
X
XSETUP:
X
X	bird.h		edit the file to select default file names.
X
X	Makefile	run "make" to compile the programs.
X
X	pk_kepl		prepare database of keplerian data.
X
X	site.DB		edit site data; east longitude, latitude.
X
X
XNOTES:
X
X	sats.DB	-	To alphabetize the sats.DB, the command line
X		cat NORAD.dat | unikepl | sort | unikepl -r | pk_kepl
X			can be used. 
X
X	birdie	-	the program prompts with "select by number: "
X			a command summary can be displayed by entering
X			a '?' character when the program prompts.
X
X
XABBREVIATIONS:
X
X	A/a		Azimuth/altitude
X	d(Km)		distance
X	dF(ppm)		doppler frequency shift
X	MJD		Modified Julian Date
X	dT		days since Epoch
X	Erev		Epoch revolution
X	nu		true anomaly, position in orbit relative perigee
X	O		RA of ascending mode
X	i		inclination of orbit relative to equator
X	w		argument of perigee
X	e		eccentricity
X	M		mean anomaly
X	N		mean motion
X	P		orbital period, minutes
X	sma(Km)		semi-major axis
X	Hmin		minimum height
X	Hmax		maximum height
X	dL/dT		time rate of change of mean longitude
X	dO/dT		precession of node per day
X	dw/dT		precession of perigee per day
X	dN/dT		time rate of change of mean motion, decay rate
X
X---
X			CLBrunow - ka5sof
X	clb@loci.uucp, loci@csccat.uucp, loci@killer.dallas.tx.us
X	  Loci Products, POB 833846-131, Richardson, Texas 75083
X
SHAR_EOF
fi # end of overwriting check
if test -f 'bird.h'
then
	echo shar: will not over-write existing file "'bird.h'"
else
echo shar: x - bird.h
sed 's/^X//' << \SHAR_EOF > 'bird.h'
X
X/*
X	Copyright (C) 1988, CLBrunow, All rights reserved.
X
X	This program is intended for hobbiest use only and
X	may not be sold.  The program may only be distributed
X	intact, including this paragraph, and no portion may
X	be used in any other program or software application
X	without prior written permission of the author.
X/**/
X
X/*	@(#)bird.h	2.4 : clb@loci.uucp */
X/*	#define	EBUG	1	/**/
X
X#include	<stdio.h>
X#include	<fcntl.h>
X#include	<math.h>
X
X#define	ushort	unsigned short
X
X#ifndef	SAT_DB
X#	define	SAT_DB	"sats.DB"
X#	define	SITE_DB	"birdsite.DB"
X#endif
X
X#define	Re		6378.140
X#define	AXIS		143826.265154
X#define	ECC_OF_GEOID	0.08182
X#define	J2 		1.082616e-3
X#define	J3 		-2.53881e-6
X#define	FUZZ		1e-6
X#define	DEGS		*(0.01745329252)
X#define	TODEG		*57.2957795131
X#define	PI		3.14159265359
X#define	PIx2		6.28318530718
X#define	PIo2		1.57079632679
X#define	TWO_THIRDS	0.66666666667
X#define	MU		398600.448
X#define	JD1970		2440587.5
X#define	RefJD		2400000.5
X#define	C_c		299792.458
X
X#define	HFLG	1
X#define	OFLG	2
X#define	KFLG	4
X#define	YFLG	8
X
Xstruct	norad
X{
X	char	sat_name[12];
X	ushort	sat_num, sat_lset, sat_erev, sat_eyr;
X	double	sat_eday, sat_n, sat_dcay;
X	float	sat_Ome, sat_i, sat_w, sat_e, sat_M;
X};
X
Xstruct sgp_sat
X{
X	double	sgp_T0, sgp_O0, sgp_O1, sgp_I0, sgp_W0, sgp_W1, sgp_E0, sgp_M0,
X		sgp_N0, sgp_N1, sgp_L1, sgp_sma, sgp_nu
X	;
X};
X
Xextern long	time();
Xextern double	MJD(), osculate();
Xextern double	dotv();
Xextern char	*sprtv();
Xextern char	*revv, *normv, *desc;
X
Xextern double	phi, lam, To, aries, lha, Ome, ome,
X		P[4], Q[4], V[4], OV[4], PP[8], QQ[8],
X		Euler[3][3], Topo[3][3], Mpert[8][8]
X;
X
Xextern struct sgp_sat	sgp_s;
Xextern struct norad	kbfr;
X
X#define	INCLDONE	1
SHAR_EOF
fi # end of overwriting check
if test -f 'birdie.c'
then
	echo shar: will not over-write existing file "'birdie.c'"
else
echo shar: x - birdie.c
sed 's/^X//' << \SHAR_EOF > 'birdie.c'
X
X/*
X	Copyright (C) 1988, CLBrunow, All rights reserved.
X
X	This program is intended for hobbiest use only and
X	may not be sold.  The program may only be distributed
X	intact, including this paragraph, and no portion may
X	be used in any other program or software application
X	without prior written permission of the author.
X/**/
X
X#include	"bird.h"
Xstatic	char	author[] = {"@(#)birdie.c	2.9 : clb@loci.uucp CLBrunow"};
X
Xstatic	char	sats_db[128] = { SAT_DB }, site_db[64] = { SITE_DB };
Xstatic	double	xT, xdy, x_incr = 3.0/1440.0, x_span = 1.0 / 24.0;
Xstatic	int	xfd, xflg, xmo, xyr, xhr, xmn, xsc;
X
Xmain(ac, av)	char	*av[];
X{
X	int	i, yr, mo;
X	char	bfr[128];
X	long	ltime;
X	double	azim, alt, dy, hr, mn, sc, T;
X
X	if(ac < 2) {		/* no arg; assume current time */
X		ltime = time(0);
X		T = JD1970 + ltime / 86400.0 - RefJD;
X	} else if(av[1][0] == '-') {
X		printf("usage: %s [JD]\t,\tusage: %s m d y [h m s]\n",
X			av[0], av[0]);
X		exit(0);
X	} else if(ac == 2) {	/* one arg; assume JD or MJD */
X		sscanf(av[1], "%lf", &dy);
X		if(dy >= 10000.)	dy -= RefJD;
X		T = dy;
X	} else {
X		yr = 88;	hr = mn = sc = 0.0;
X		sscanf(av[1], "%d", &mo);
X		sscanf(av[2], "%lf", &dy);
X		sscanf(av[3], "%d", &yr);
X		sscanf(av[4], "%lf", &hr);
X		sscanf(av[5], "%lf", &mn);
X		sscanf(av[6], "%lf", &sc);
X		T = MJD(yr, mo, dy) + (hr+(mn+sc/60.0)/60.0)/24.0;
X	}
X	xT = T;
X
X	if((xfd = open(site_db, 0)) < 0)	site_err(av[0], site_db);
X	read(xfd, bfr, 128);
X	sscanf(bfr, " %lf %lf", &lam, &phi);
X	lam = lam DEGS;	phi = phi DEGS;
X	close(xfd);
X
X	xflg = HFLG;
X#ifdef	MSDOS
X	if((xfd = open(sats_db, O_RDONLY | O_BINARY)) < 0)	exit(1);
X#else
X	if((xfd = open(sats_db, 0)) < 0)	exit(1);
X#endif
X	while(sat_lup());
X	exit(0);
X}
X
Xsat_lup()
X{
X	char	bfr[128];
X	long	loff;
X
X	printf("\n>< select by number: ");
X	gets(bfr);
X	switch(*bfr) {
X		case '\0':	sat_names(xfd, 5);	return(1);
X		case 'm': case 'M':
X			sscanf(bfr+1, " %lf", &xT);
X			if(xT == 0.0)
X				xT = JD1970 + time(0) / 86400.0 - RefJD;
X			return(1);
X		case 't': case 'T': sscanf(bfr+1, " %d %d %d", &xhr,&xmn,&xsc);
X			xT = MJD(xyr, xmo, xdy)+(xhr+(xmn+xsc/60.0)/60.0)/24.0;
X			return(1);
X		case 'd': case 'D': sscanf(bfr+1," %lf %d %d", &xdy,&xmo,&xyr);
X			xT = MJD(xyr, xmo, xdy);	return(1);
X		case 'i': case 'I': sscanf(bfr+1, " %lf", &x_incr);
X			x_incr /= 1440.0; return(1);	/* min's */
X		case 's': case 'S': sscanf(bfr+1, " %lf", &x_span);
X			x_span /= 24.0;	return(1);	/* hr's */
X		case 'f': case 'F': set_frmt(bfr+1); return(1);
X		case 'u': case 'U': sats_up(xfd, xflg, xT);	return(1);
X		case 'r': case 'R': sscanf(bfr+1, " %ld", &loff);
X			if(!sk_num(xfd, loff))	return(0);
X	printf("[%5d]\t%12s\tMJD= %.8f, span(hr)= %.2f, incr(mn)= %.1f\n",
X				kbfr.sat_num, kbfr.sat_name,
X				xT, x_span * 24.0, x_incr * 1440.0
X			);
X			sats_step(xflg, xT);	return(1);
X		case 'q': case 'Q': return(0);
X		case 'h': case '?': prt_help();	return(1);
X		default:	sscanf(bfr, " %ld", &loff);	break;
X	}
X	if(sk_num(xfd, loff)) {
X		printf("[%5d]\t%12s\n", kbfr.sat_num, kbfr.sat_name);
X		do_sat(xT);
X		frmt_sat(xflg, xT);
X		return(1);
X	} else	return(0);
X}
X
Xsk_num(fd, loff)	long loff;
X{
X	short	ret;
X
X	if(loff < 8000L) {
X		lseek(fd, (loff-1) * sizeof(struct norad), 0);
X		return(set_sgp(&sgp_s, fd));
X	}
X	lseek(fd, 0L, 0);
X	while((ret = set_sgp(&sgp_s, fd)))
X		if(kbfr.sat_num == loff)
X			return(ret);
X	return(0);
X}
X
Xset_frmt(sp)	char *sp;
X{
X	xflg = 0;
X	while(*sp) {
X		switch(*sp++) {
X			case 'a':	xflg |= HFLG;	break;
X			case 'k':	xflg |= KFLG;	break;
X			case 'e':	xflg |= OFLG;	break;
X			case 'v':	xflg = HFLG | KFLG | OFLG; break;
X		}
X	}
X}
X
Xsats_up(fd, flg, mjd)	double mjd;
X{
X	static double	lP[4], lV[4];
X	double	azim, alt, vel_radial, vel_rel;
X
X	top_xyz(RefJD + mjd, lam, phi);		/**/
X	OV[1] = 0.465101358218 * cos(phi);	/* obs vel, km/s */
X	lseek(fd, 0L, 0);
X	while(set_sgp(&sgp_s, fd)) {
X		do_sat(mjd);
X		rotv(3, QQ, Topo, PP);
X		rotv(3, &QQ[4], Topo, &PP[4]);
X		cpyv(3, lP, QQ);
X
X		lP[2] -= Re;
X		if(lP[2] < 0.0)	continue;
X		lP[3] = sqrt(dotv(3, lP, lP));
X		if((azim = atan2(lP[1], lP[0])) > PIx2)	azim -= PIx2;
X		else if(azim < 0.0)	azim += PIx2;
X		alt = asin(lP[2] / lP[3]);
X		printf("[%5d]\t%12s\t", kbfr.sat_num, kbfr.sat_name);
X		printf("A/a= %5.1f, %4.1f; d(Km)= %6.0f, ",
X			azim TODEG, alt TODEG, lP[3]);
X		cpyv(4, lV, &QQ[4]);
X		subv(2, lV, OV);
X		vel_radial = dotv(3, lP, lV) / lP[3];
X		vel_rel = vel_radial / C_c;
X		printf("dF(ppm)= %+.4f\n", -1.0e6 * vel_rel);
X	}
X}
X
Xsats_step(flg, mjd)	double mjd;
X{
X	double	lT, eT;
X
X	eT = mjd + x_span;
X	for(lT=mjd; lT <= eT; lT += x_incr) {
X		do_sat(lT);
X		frmt_sat(flg, lT);
X	}
X}
X
Xdo_sat(T)	double T;
X{
X	pre_pert(T, &sgp_s);
X	kepl(T, QQ, &sgp_s);
X/*
X	set_grav(8, Mpert, QQ);
X	postpert(PP, QQ);	/**/
X	cpyv(8, PP, QQ);
X}
X
Xfrmt_sat(fflg, T)	double T;
X{
X	if(fflg & HFLG)	hznv(T, PP);
X	if(fflg & KFLG)	prt_kepl(T, &sgp_s);
X	if(fflg & OFLG)	prt_epoch(&sgp_s);
X}
X
Xhznv(mjd, pp)	double mjd, pp[];
X{
X	static double	lP[4], lV[4];
X	double	azim, alt, vel_radial, vel_rel;
X
X	top_xyz(RefJD + mjd, lam, phi);		/**/
X	OV[1] = 0.465101358218 * cos(phi);	/* obs vel, km/s */
X
X	rotv(3, QQ, Topo, pp);
X	rotv(3, &QQ[4], Topo, &pp[4]);
X	cpyv(3, lP, QQ);
X
X	lP[2] -= Re;
X	lP[3] = sqrt(dotv(3, lP, lP));
X	if((azim = atan2(lP[1], lP[0])) > PIx2)	azim -= PIx2;
X	else if(azim < 0.0)	azim += PIx2;
X	alt = asin(lP[2] / lP[3]);
X	printf("A/a= %5.1f, %5.1f, d(Km)= %6.0f,\t",
X		azim TODEG, alt TODEG, lP[3]);
X
X	cpyv(4, lV, &QQ[4]);
X	subv(2, lV, OV);
X	vel_radial = dotv(3, lP, lV) / lP[3];
X	vel_rel = vel_radial / C_c;
X	printf("dF(ppm)= %+.4f\t%f\n", -1.0e6 * vel_rel, mjd);
X}
X
Xsite_err(pn, fn)	char *pn, *fn;
X{
X	printf("%s: site data file, '%s', not found\n", pn, fn);
X}
X
X#ifndef	INCLDONE
X#include	"bird.h"
Xstatic char	author[] = "@(#)bird.fmt.c	2.5 : clb@loci.uucp";
X#endif
X
X#define	HELP_LEN	14
Xchar	*helptext[] =
X{
X	"Command Summary:",
X	"\t[uU]\t\t... list sats above horizon",
X	"\t[mM] MJD\t... set MJD (0 sets at current time)",
X	"\t[dD] day mon yr\t... set date",
X	"\t[tT] hr min sec\t... set time (date must be set prior)",
X	"\t[rR] sat\t... repeat from MJD over span at incr",
X	"\t[sS] span\t... set span (hours); used with 'r'",
X	"\t[iI] incr\t... set incr (minutes); used with 'r'",
X	"\t[fF] modes\t... set format",
X	"\t\ta  enables Azim/alt display",
X	"\t\tk  enables Keplerian display",
X	"\t\te  enables Epoch display",
X	"\t\tv  enables all above displays",
X	"\t[qQ] quits, exits the program",
X	""
X};
X
Xprt_help()
X{
X	short	i;
X
X	for(i=0; i<HELP_LEN; i++)
X		puts(helptext[i]);
X}
X
Xprt_epoch(p)	struct sgp_sat	*p;
X{
X	double	nn, sma, dL;
X
X	printf("Epoch:\t%.8f\n", p->sgp_T0);
X	printf("O= %.4f, i= %.4f, w= %.4f, e= %f, M= %.4f, N= %f\n",
X		p->sgp_O0 TODEG, p->sgp_I0 TODEG, p->sgp_W0 TODEG,
X		p->sgp_E0, p->sgp_M0 TODEG, p->sgp_N0 / PIx2
X	);
X	dL = p->sgp_O1 + p->sgp_W1 + p->sgp_N0;
X	printf("dO/dT= %f, dw/dT= %.4f, dN/dT= %f, dL/dT= %f\n",
X		p->sgp_O1 TODEG, p->sgp_W1 TODEG, p->sgp_N1 / PIx2, dL / PIx2
X	);
X	sma = AXIS * pow(dL, -TWO_THIRDS);
X	printf("P= %.2f, sma (Km) = %.0f, Hmin = %.0f, Hmax = %.0f\n",
X		1440.0*PIx2/dL, sma, sma*(1.0-p->sgp_E0) - Re,
X		sma * (1.0 + p->sgp_E0) - Re
X	);
X}
X
X#ifdef	BSD
Xdouble fmod(x, k)	double x, k;
X{
X	return(x - k * floor(x / k));
X}
X#endif
X
Xprt_kepl(T, p)	double T; struct sgp_sat *p;
X{
X	double	nn, sma, drev, dL, dT, O, W, M, N;
X
X	dT = T - p->sgp_T0;
X	O = p->sgp_O0 + p->sgp_O1 * dT;
X	if(O < 0.0)	O += PIx2;
X	else if(O > PIx2) O -= PIx2;
X	W = p->sgp_W0 + p->sgp_W1 * dT;
X	if(W < 0.0)	W += PIx2;
X	else if(W > PIx2) W -= PIx2;
X	drev = (p->sgp_N0 + 0.5 * p->sgp_N1 * dT) * dT;
X	M = p->sgp_M0 + drev;
X	drev += p->sgp_W0;
X	drev /= PIx2;
X	if(dT < 0.0)	--drev;
X	printf("MJD: %.8f,\tdT= %.8f,\tErev%+d,\tnu= %.4f\n",
X		T, dT, (int)drev, p->sgp_nu TODEG
X	);
X	while(M < 0.0)	M += PIx2;
X	M = fmod(M, PIx2);
X	N = p->sgp_N0 + p->sgp_N1 * dT;
X	printf("O= %.4f, i= %.4f, w= %.4f, e= %f, M= %.4f, N= %f\n",
X		O TODEG, p->sgp_I0 TODEG, W TODEG, p->sgp_E0, M TODEG, N / PIx2
X	);
X	dL = p->sgp_L1;
X	sma = AXIS * pow(dL, -TWO_THIRDS);
X	printf("P= %.2f, sma(Km)= %.0f, Hmin= %.0f, Hmax= %.0f, dL/dT= %f\n",
X		1440.0 * PIx2/dL, sma, sma * (1.0-p->sgp_E0) - Re,
X		sma * (1.0 + p->sgp_E0) - Re, dL / PIx2
X	);
X}
X
X#ifndef	INCLDONE
X#include	"bird.h"
Xstatic char	author[] = {"@(#)bird.sbr.c	2.7 : clb@loci.uucp CLBrunow"};
X#endif
X
Xpre_pert(t, ssp)	double t; struct sgp_sat *ssp;
X{
X	double	dM, a, sma, b2, p, si, ci, temp, M1, N;
X
X	b2 = 1.0 - ssp->sgp_E0 * ssp->sgp_E0;
X	si = sin(ssp->sgp_I0);	ci = cos(ssp->sgp_I0);
X	t -= ssp->sgp_T0;
X	N = ssp->sgp_N0;
X	dM = N + 2.0 * ssp->sgp_N1 * t;
X	p = 22.54987585 * pow(N, -0.666666667) * b2;
X	temp = 0.75 * J2 / (p * p);
X	ssp->sgp_W1 = N * temp * (5.0*ci*ci - 1.0);
X	ssp->sgp_O1 = -2.0*N*temp*ci;
X	ssp->sgp_L1 = ssp->sgp_O1 + ssp->sgp_W1 + dM;
X	if(ssp->sgp_L1 < 0)	ssp->sgp_sma = 1e9;
X	else	ssp->sgp_sma = 143826.265154 * pow(ssp->sgp_L1, -0.666666667);
X}
X
Xset_grav(n, mtrx, vctr)	double *mtrx, *vctr;
X{
X	untm(n, mtrx);
X}
X
Xpostpert(p, q)	double *p, *q;
X{
X	rotv(8, p, Mpert, q);
X/*	*(p+3) = sqrt(dotv(3, p, p));
X	*(p+7) = sqrt(dotv(3, p+4, p+4));	/**/
X}
X
Xkepl(mjd, qq, ssp)	double mjd, *qq; struct sgp_sat *ssp;
X{
X	double	a, v, t, M, nn, dM;
X
X	t = mjd - ssp->sgp_T0;
X	nn = ssp->sgp_N0 + ssp->sgp_N1 * t;	/**/
X	dM = ssp->sgp_N0 + 0.5 * ssp->sgp_N1 * t;
X	Ome = ssp->sgp_O0 + t * ssp->sgp_O1;	/* RA of node */
X	ome = ssp->sgp_W0 + t * ssp->sgp_W1;	/* Arg of perigee */
X	M = fmod(ssp->sgp_M0 + dM * t, PIx2);
X	eul3m(Euler, Ome, ssp->sgp_I0, ome);
X	ssp->sgp_nu = osculate(qq, ssp->sgp_E0, M);
X	a = ssp->sgp_sma;
X	v = sqrt(398600.448 / a);	/* vel in km/s */
X	xyz(qq, a, v);
X}
X
Xxyz(qq, a, v)	double *qq, a, v;
X{
X	double	pp[3];
X
X	rotv(3, pp, Euler, qq);		wgtv(3, pp, a); cpyv(3, qq, pp);
X	rotv(3, pp, Euler, qq+4);	wgtv(3, pp, v); cpyv(3, qq+4, pp);
X	*(qq+3) *= a;	*(qq+7) *= v;
X}
X
Xdouble	osculate(qq, e, M)	double	*qq, e, M;
X{
X	double	E, r, v, v0, v1, ee, nu, t, cn, sn;
X
X	E = M;
X	do {
X		E -= (t = E - e * sin(E) - M);
X	} while(t > FUZZ || t < -FUZZ);
X
X	r = (1 - e * cos(E));
X	v = 1.0 / (r*r);
X	ee = sqrt((1.0+e)/(1.0-e));
X	nu = 2.0 * atan2(ee * sin(E/2), cos(E/2));
X	cn = r * cos(nu);	sn = r * sin(nu);
X	E -= M; ee = sqrt(1.0-e*e);
X	
X	*qq++ = cn; *qq++ = sn; *qq++ = 0.0; *qq++ = r;
X	v0 = v *(E*cn - ee*sn);
X	v1 = v *(ee*cn + E*sn);
X	*qq++ = v0; *qq++ = v1;	*qq++ = 0.0;
X	*qq = sqrt(2.0/r-1.0);
X	return(nu);
X}
X
Xdouble	MJD(yr, mo, d)	double d;
X{
X	short	i;
X	static short	mondys[2][12] = {
X		{	0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334 },
X		{	0, 31, 60, 91, 121, 152, 182, 213, 244, 274, 305, 335 }
X	};
X 
X	if(yr < 68)	return(-1);
X	yr -= 68;
X	i = yr%4 ? 0 : 1;
X	for(; yr>3; yr-=4)	d += 1461.0;
X	if(yr) d += 1.0;
X	while(yr--)	d += 365.0;
X	d += mondys[i][--mo];	/**/
X	return(d + 39855);
X}
X
Xsat_names(ifd, ncol)
X{
X	int		sat_no;
X	struct norad	kbfr;
X
X	sat_no = 0;
X	lseek(ifd, 0L, 0);
X	while(read(ifd, &kbfr, sizeof(kbfr)) == sizeof(kbfr)) {
X		printf("%3d:%-11s", ++sat_no, kbfr.sat_name);
X		if(sat_no % ncol == 0)	printf("\n");
X		else	printf(" ");
X	}
X	printf("\n");
X	return(sat_no);
X}
X
Xset_sgp(ps, fd)	struct sgp_sat	*ps;
X{
X	char	*p;
X	short	index;
X
X	if(read(fd, &kbfr, sizeof(struct norad)) != sizeof(struct norad))
X		return(0);
X	p = &kbfr.sat_name[10];
X	for(index=0; index<12; --p, index++)
X		if(*p != ' ')	break;
X		else	*p = '\0';
X
X	ps->sgp_T0 = MJD(kbfr.sat_eyr, 1, kbfr.sat_eday);
X	ps->sgp_I0 = kbfr.sat_i DEGS;
X	ps->sgp_O0 = kbfr.sat_Ome DEGS;
X	ps->sgp_E0 = kbfr.sat_e;
X	ps->sgp_W0 = kbfr.sat_w DEGS;
X	ps->sgp_M0 = kbfr.sat_M DEGS;
X	ps->sgp_N0 = kbfr.sat_n * PIx2;
X	ps->sgp_N1 = kbfr.sat_dcay * PIx2;
X	return(1);
X}
X
X#ifndef	INCLDONE
X#include	"bird.h"
Xstatic	char	author[] = {"@(#)bird.rot.c	2.3 : clb@loci.uucp"};
X#endif
X
Xtop_xyz(jd)
Xdouble	jd;
X{
X	double	gmst, T, the;
X
X	T = (jd - 2451545.0) / 36525.0;
X	gmst = 0.279057273264+
X		T*(100.002139038+T*(1.07759259259e-06-T*7.17592592593e-11));
X	gmst = fmod(gmst, 1.0);
X	gmst += fmod(jd-0.5, 1.0);
X	gmst *= PIx2;
X	aries = gmst;
X	the = gmst + lam;
X	lha = the;
X	top3m(Topo, the, phi);
X}
X
Xaddv(N, p, q)	register N; double *p, *q; { while(N--)	*p++ += *q++; }
Xsubv(N, p, q)	register N; double *p, *q; { while(N--)	*p++ -= *q++; }
Xwgtv(N, p, w)	register N; double *p,  w; { while(N--)	*p++ *= w; }
X
Xdouble	dotv(N, p, q)	register N; double *p, *q;
X{			/* dot product of vectors: p = p * q /**/
X	double	t;
X
X	t = 0.0;
X	while(N--)	t += *p++ * *q++;
X	return(t);
X}
X
Xdouble	lenv(N, p)	short N; double *p;
X{
X	return(sqrt(dotv(N, p, p)));
X}
X
X#define	VCT_FRMT	" %8.4g"
X
X
Xrotv(N, p, m, q)	register N; double *p, *m, *q;
X{			/* matrix op on vector: p = [m] * q /**/
X	register	i, j;
X
X	for(i=0; i<N; i++)
X		for(p[i]=0.0,j=0; j<N; j++)
X			p[i] += *m++ * q[j];
X}
X
Xuntm(N, p)	short N; double *p;	/* init NxN mtrx to Identity /**/
X{
X	short	i, k;
X
X	k = N * N;	N++;	clrv(k, p);
X	for(i=0; i<k; i+=N, p+=N) *p = 1.0;
X}
X
Xclrv(N, p)	register N; double *p;	   { while(N--) *p++ = 0.0;	}
Xcpyv(N, p, q)	register N; double *p, *q; { while(N--) *p++ = *q++;	}
Xsetv(N, p, vs)	register N; double *p, vs;	/* put args in vct /**/
X{	double	*pp; pp = &vs;	while(N--) *p++ = *pp++; }
X
Xtop3m(T, lam, phi)	/* convert obs lg,lt to rotation matrix */
Xdouble	*T, lam, phi;	/* use to rotate eqt vectors to Azim,alt */
X{
X	double		sl, cl, sf, cf, zz;
X
X	zz = 0.0;
X	sl = sin(lam);	cl = cos(lam);	sf = sin(phi);	cf = cos(phi);
X	*T++ = -cl*sf;	*T++ = -sl*sf;	*T++ = cf;
X	*T++ = -sl;	*T++ = cl;	*T++ = zz;
X	*T++ = cl*cf;	*T++ = sl*cf;	*T   = sf;
X}
X
Xeul3m(E, psi, theta, phi)	double *E, psi, theta, phi;
X{
X	double	cf, sf, cy, sy, cj, sj, cfcy, cfsy, sfcy, sfsy;
X
X	cy = cos(psi);		sy = sin(psi);
X	cj = cos(theta);	sj = sin(theta);
X	cf = cos(phi);		sf = sin(phi);
X	cfcy = cf * cy;		cfsy = cf * sy;
X	sfcy = sf * cy;		sfsy = sf * sy;
X	*E++ = cfcy-sfsy*cj;	*E++ = -sfcy-cfsy*cj;	*E++ = sj*sy;
X	*E++ = cfsy+sfcy*cj;	*E++ = -sfsy+cfcy*cj;	*E++ = -sj*cy;
X	*E++ = sj*sf;	 	*E++ =  sj*cf;		*E   = cj;
X}
X
X#ifndef	INCLDONE
X#include	"bird.h"
Xstatic char	author[] = {"@(#)bird.dta.c	2.2 : clb@loci.uucp CLBrunow"};
X#endif
X
Xstruct sgp_sat	sgp_s;
Xstruct norad	kbfr;
X
Xdouble	phi, lam, To, aries, lha, Ome, ome,
X	P[4], Q[4], V[4], OV[4], PP[8], QQ[8],
X	Euler[3][3], Topo[3][3], Mpert[8][8]
X;
X
SHAR_EOF
fi # end of overwriting check
if test -f 'birdsite.DB'
then
	echo shar: will not over-write existing file "'birdsite.DB'"
else
echo shar: x - birdsite.DB
sed 's/^X//' << \SHAR_EOF > 'birdsite.DB'
X-96.683 32.9333 # longitude (east), latitude
SHAR_EOF
fi # end of overwriting check
if test -f 'lstkepl.c'
then
	echo shar: will not over-write existing file "'lstkepl.c'"
else
echo shar: x - lstkepl.c
sed 's/^X//' << \SHAR_EOF > 'lstkepl.c'
X
X/*
X	Copyright (C) 1988, CLBrunow, All rights reserved.
X
X	This program is intended for hobbiest use only and
X	may not be sold.  The program may only be distributed
X	intact, including this paragraph, and no portion may
X	be used in any other program or software application
X	without prior written permission of the author.
X/**/
X
X#include	"bird.h"
X
Xstruct	norad	kbfr;
Xchar	bfr[512];
X
Xmain(argc, argv)	char *argv[];
X{
X	int	i, ifd, sat_no, flg;
X
X	flg = sat_no = 0;
X	if(argc > 1) {
X		i = 1;
X		if(argv[1][0] == '-') {
X			switch(argv[1][1]) {
X				case 'a':	flg = 2;	break;
X				case 'l':	flg = 0;	break;
X				case 'n':	flg = 1;	break;
X				default:	usage(*argv);
X			}
X			i++;
X		}
X		if(argc > i)	sscanf(argv[i], "%d", &sat_no);
X	}
X#ifdef	MSDOS
X	if((ifd = open(SAT_DB, O_RDONLY | O_BINARY)) < 0) {
X#else
X	if((ifd = open(SAT_DB, O_RDONLY)) < 0) {
X#endif
X		printf("can't open database file: %s\n", SAT_DB);
X		exit(1);
X	}
X	if(flg == 0) {
X		sat_names(ifd, 3);
X		exit(0);
X	}
X	while(read(ifd, &kbfr, sizeof(kbfr)) == sizeof(kbfr))
X		if(!sat_no || sat_no == kbfr.sat_num)
X			switch(flg) {
X				case 0:
X				case 1: prt_nasa(&kbfr);	break;
X				case 2: prt_amsat(&kbfr);
X				default:	break;
X			}
X	exit(0);
X}
X
Xprt_amsat(p)	struct norad *p;
X{
X	long	lset, erev;
X
X	printf("Satellite: %s\n", p->sat_name);
X	printf("Catalog number: %d\n", p->sat_num);
X	printf("Epoch time: %d%012.8lf\n", p->sat_eyr, p->sat_eday);
X	lset = p->sat_lset;
X	printf("Element set: %ld\n", lset);
X	printf("Inclination: %8.4f deg\n", p->sat_i);
X	printf("RA of node: %8.4f deg\n", p->sat_Ome);
X	printf("Eccentricity: %8.7f\n", p->sat_e);
X	printf("Arg of perigee: %8.4f deg\n", p->sat_w);
X	printf("Mean anomaly: %8.4f deg\n", p->sat_M);
X	printf("Mean motion: %11.8f rev/day\n", p->sat_n);
X	printf("Decay rate: %11.8f rev/day^2\n", p->sat_dcay);
X	erev = p->sat_erev;
X	printf("Epoch rev: %ld\n", erev);
X	printf("\n");
X}
X
Xprt_nasa(p)	struct norad *p;
X{
X	char	sgn, bfr[80];
X	long	le, lset, erev;
X
X	printf("%-11s\n", p->sat_name);
X	if(p->sat_dcay < 0.0) {
X		p->sat_dcay = -p->sat_dcay;
X		sgn = '-';
X	} else	sgn = '0';
X	lset = p->sat_lset;
X	sprintf(bfr,
X		"1 %5dU          %2d%12.8f %10.8f  00000-0  00000-0 0 %4ld",
X		p->sat_num, p->sat_eyr, p->sat_eday, p->sat_dcay, lset
X	);
X	bfr[33] = sgn;
X	printf("%s%d\n", bfr, ck_sum(bfr));
X	erev = p->sat_erev;
X	le = (long) (p->sat_e * 1.0e+7);
X	sprintf(bfr, "2 %5d %8.4f %8.4f %07ld %8.4f %8.4f %11.8f%5ld",
X		p->sat_num, p->sat_i, p->sat_Ome, le,
X		p->sat_w, p->sat_M, p->sat_n, p->sat_erev, 0
X	);
X	printf("%s%d\n", bfr, ck_sum(bfr));
X}
X
Xck_sum(s)	char *s;
X{
X	int	c, i, sum;
X
X	sum = 0;
X	for(i=0; i<68; i++)
X	{
X		c = *s++;
X		if(c > '9' || c == ' ' || c == '.')	c = 0;
X		else if(c == '-')			c = 1;
X		else					c &= 15;
X		sum += c;
X	}
X	return(sum%10);
X}
X
Xusage(p)	char *p;
X{
X	fprintf(stderr, "usage: %s -[lan]\n", p);
X	exit(1);
X}
X
Xsat_names(ifd, ncol)
X{
X	int		sat_no;
X	struct norad	kbfr;
X
X	sat_no = 0;
X	lseek(ifd, 0L, 0);
X	while(read(ifd, &kbfr, sizeof(kbfr)) == sizeof(kbfr)) {
X		printf("\t%5d: %s", kbfr.sat_num, kbfr.sat_name);
X		if(++sat_no % ncol == 0)	printf("\n");
X	}
X	printf("\n\n");
X	return(sat_no);
X}
X
SHAR_EOF
fi # end of overwriting check
if test -f 'norad.dat'
then
	echo shar: will not over-write existing file "'norad.dat'"
else
echo shar: x - norad.dat
sed 's/^X//' << \SHAR_EOF > 'norad.dat'
X# Sample data from NASA Bulletins #379 -
XLAGEOS     
X1 08820U          88257.39742307 0.00000003           10000-2 0  5602
X2 08820 109.8219 135.3202 0044484  14.9438 345.2713  6.38663870 32950
XGOES 2     
X1 10061U          88254.54271214 -.00000008                   0  1440
X2 10061   6.4610  71.5705 0010614 152.4402 207.8714  1.00268181  2572
XGPS-0001   
X1 10684U          88257.23559917 0.00000013                   0  9509
X2 10684  63.4921 109.4605 0100873 196.9068 162.8222  2.00564015 62979
XGPS-0002   
X1 10893U          88253.19996951 -.00000029                   0  9154
X2 10893  64.5701 350.3393 0142967  30.4869 330.3624  2.00563619 75714
XSeaSat 1   
X1 10967U          88256.98262614 0.00000389           18328-3 0   186
X2 10967 108.0093  77.1339 0002373 261.7901  98.2959 14.33869243534341
XGPS-0003   
X1 11054U          88252.52153717 -.00000029                   0  9414
X2 11054  64.1386 346.9149 0051726 120.2168 240.3316  2.00570175 72711
XGPS-0004   
X1 11141U          88253.12271087 0.00000013                   0   333
X2 11141  63.4608 109.4415 0055000 325.6680  34.0776  2.00559521 71421
XNOAA 6     
X1 11416U          88253.42523444 0.00000383           17908-3 0  7547
X2 11416  98.4975 252.9735 0011530 207.0321 153.0259 14.25195038477905
XSolar Max  
X1 11703U          88254.76848220 0.00013349           41610-3 0  6852
X2 11703  28.5015  55.5230 0002757 153.1808 206.8934 15.31654847476724
XGPS-0006   
X1 11783U          88253.08188441 -.00000029                   0  8012
X2 11783  63.9530 346.5349 0131986  65.7523 295.6526  2.00559714 61362
XGOES 4     
X1 11964U          88253.36408955 -.00000240           10000-3 0   112
X2 11964   4.7788  76.3926 0002260 116.5290 243.8365  1.00268789 45050
XGOES 5     
X1 12472U          88250.45841753 -.00000247           10000-3 0  6260
X2 12472   1.8191  84.6376 0000434  60.1839 301.5924  1.00261849 25765
XUOSAT 1    
X1 12888U          88255.05425879 0.00013940           41364-3 0  2917
X2 12888  97.6104 290.6043 0003619  97.4550 262.6951 15.34926629385902
SHAR_EOF
fi # end of overwriting check
if test -f 'pk_kepl.c'
then
	echo shar: will not over-write existing file "'pk_kepl.c'"
else
echo shar: x - pk_kepl.c
sed 's/^X//' << \SHAR_EOF > 'pk_kepl.c'
X
X/*
X	Copyright (C) 1988, CLBrunow, All rights reserved.
X
X	This program is intended for hobbiest use only and
X	may not be sold.  The program may only be distributed
X	intact, including this paragraph, and no portion may
X	be used in any other program or software application
X	without prior written permission of the author.
X/**/
X
X#include	"bird.h"
X
Xstruct norad	kbfr;
X
Xmain()
X{
X	char	bfr[512];
X	int	ifd, ofd, sat_cnt, cksum;
X
X	if((ofd = creat(SAT_DB, 0664)) < 0)
X		printf("can't create output file: %s\n", SAT_DB);
X#ifdef	MSDOS
X	close(ofd);
X	if((ofd = open(SAT_DB, O_WRONLY | O_BINARY)) < 0)
X		printf("can't re-open output file: %s\n", SAT_DB);
X#endif
X	sat_cnt = 0;
X	while(gets(bfr) != NULL) {
X		if(*bfr == '#') {
X			puts(bfr);
X			continue;
X		}
X		strcpy(kbfr.sat_name, bfr);
X		gets(bfr);
X		if (bfr[0] != '1') {
X			printf("\n%s: sync error\n", kbfr.sat_name);
X			continue;
X		}
X		if(ck_sum(bfr)) {
X			printf("\n%s: checksum error (1)", kbfr.sat_name);
X			continue;
X		}
X		prs_lin1(&kbfr, bfr);
X
X		gets(bfr);
X		if (bfr[0] != '2') {
X			printf("\n%s: sync error\n", kbfr.sat_name);
X			continue;
X		}
X		if(ck_sum(bfr)) {
X			printf("\n%s: checksum error (2)", kbfr.sat_name);
X			continue;
X		}
X		prs_lin2(&kbfr, bfr);
X		sat_cnt++;
X		write(ofd, &kbfr, sizeof(struct norad));
X	}
X	printf("orbit records: %d\n", sat_cnt);
X	exit(0);
X}
X
Xck_sum(s) char	*s;
X{
X	int	c, i, sum;
X
X	sum = 0;
X	if(strlen(s) < 69)
X		return(-1);
X	for(i=0; i<68; i++)
X	{
X		c = *s++;
X		if(c > '9' || c == ' ' || c == '.')
X			c = 0;
X		else if(c == '-')
X			c = 1;
X		else	c &= 15;
X		sum += c;
X	}
X	sum -= *s & 15;
X	return(sum%10);
X}
X
Xprs_lin1(p, s) struct norad	*p; char *s;
X{
X	int	num, eyr;
X	long	tail;
X
X	sscanf(s, "%*2c%5d%*10c%2d%12lf%10lf%*21c%ld",
X		&num,&eyr,&p->sat_eday,&p->sat_dcay,&tail);
X	p->sat_num = num;
X	p->sat_eyr = eyr;
X	p->sat_lset = tail / 10;   /* strip off checksum */
X}
X
Xprs_lin2(p, s) struct norad	*p; char *s;
X{
X	long	tail;
X
X	sscanf(s, "%*8c %f %f %f %f %f%11lf %ld",
X		&p->sat_i, &p->sat_Ome, &p->sat_e,
X		&p->sat_w, &p->sat_M, &p->sat_n, &tail
X	);
X	p->sat_erev = tail / 10;
X	p->sat_e *= 1e-7;	/* scale ecc */
X}
X
SHAR_EOF
fi # end of overwriting check
if test -f 'unikepl.c'
then
	echo shar: will not over-write existing file "'unikepl.c'"
else
echo shar: x - unikepl.c
sed 's/^X//' << \SHAR_EOF > 'unikepl.c'
X
X/*
X	Copyright (C) 1988, CLBrunow, All rights reserved.
X
X	This program is intended for hobbiest use only and
X	may not be sold.  The program may only be distributed
X	intact, including this paragraph, and no portion may
X	be used in any other program or software application
X	without prior written permission of the author.
X/**/
X
X	/* compact NASA Keplerians into one-liner format */
X	/* 	w/ -r flag, reverse operation (1-line to 3) */
X#include	<stdio.h>
X
Xchar	catbfr[256], bfr[128];
X
Xmain(ac, av)	char	*av[];
X{
X	if(ac > 1)
X		if(av[1][1] == 'r')	unline();
X		else			usage(av[0]);
X	else		cat3();
X}
X
Xcat3()
X{
X	register	i;
X
X	while(gets(catbfr) != NULL)
X	{
X		if(*catbfr == '#')
X		{
X			puts(catbfr);
X			continue;
X		}
X		i = strlen(catbfr);
X		while(i < 11)
X			catbfr[i++] = ' ';
X		catbfr[11] = ';';
X		catbfr[12] = '\0';
X		gets(bfr);
X		if (bfr[0] != '1')
X		{
X			printf("Line 1 missing: %s\n", catbfr);
X			continue;
X		}
X		strcat(catbfr, bfr);
X		strcat(catbfr, ";");
X		gets(bfr);
X		if (bfr[0] != '2')
X		{
X			printf("Line 2 missing: %s\n", catbfr);
X			continue;
X		}
X		strcat(catbfr, bfr);
X		puts(catbfr);
X	}
X}
X
Xunline()
X{
X	char	*p;
X
X	while(gets(catbfr) != NULL)
X	{
X		if(*catbfr == '#')
X		{
X			puts(catbfr);
X			continue;
X		}
X		for(p=catbfr; *p; p++)
X			if(*p == ';')	putchar('\n');
X			else		putchar(*p);
X		putchar('\n');
X	}
X}
X
Xusage(pn)	char *pn;
X{
X	printf("%s: convert NORAD 3-line format to 1-line and inverse\n", pn);
X	printf("usage: %s < 3-line > 1-line\n", pn);
X	printf("usage: %s -r < 1-line > 3-line\n", pn);
X}
SHAR_EOF
fi # end of overwriting check
#End of shell archive
exit 0
